Title: WP_REST_Search_Controller
Published: December 6, 2018
Last modified: February 24, 2026

---

# class WP_REST_Search_Controller {}

## In this article

 * [Description](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/?output_format=md#description)
    - [See also](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/?output_format=md#see-also)
 * [Methods](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/?output_format=md#methods)
 * [Source](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/?output_format=md#source)
 * [Related](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/?output_format=md#related)
 * [Changelog](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/?output_format=md#changelog)

[ Back to top](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/?output_format=md#wp--skip-link--target)

Core class to search through all WordPress content via the REST API.

## 󠀁[Description](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/?output_format=md#description)󠁿

### 󠀁[See also](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/?output_format=md#see-also)󠁿

 * [WP_REST_Controller](https://developer.wordpress.org/reference/classes/wp_rest_controller/)

## 󠀁[Methods](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/?output_format=md#methods)󠁿

| Name | Description | 
| [WP_REST_Search_Controller::__construct](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/__construct/) | Constructor. | 
| [WP_REST_Search_Controller::get_collection_params](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/get_collection_params/) | Retrieves the query params for the search results collection. | 
| [WP_REST_Search_Controller::get_item_schema](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/get_item_schema/) | Retrieves the item schema, conforming to JSON Schema. | 
| [WP_REST_Search_Controller::get_items](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/get_items/) | Retrieves a collection of search results. | 
| [WP_REST_Search_Controller::get_items_permission_check](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/get_items_permission_check/) | Checks if a given request has access to search content. | 
| [WP_REST_Search_Controller::get_search_handler](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/get_search_handler/) | Gets the search handler to handle the current request. | 
| [WP_REST_Search_Controller::prepare_item_for_response](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/prepare_item_for_response/) | Prepares a single search result for response. | 
| [WP_REST_Search_Controller::register_routes](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/register_routes/) | Registers the routes for the search controller. | 
| [WP_REST_Search_Controller::sanitize_subtypes](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/sanitize_subtypes/) | Sanitizes the list of subtypes, to ensure only subtypes of the passed type are included. |

## 󠀁[Source](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/?output_format=md#source)󠁿

    ```php
    class WP_REST_Search_Controller extends WP_REST_Controller {

    	/**
    	 * ID property name.
    	 */
    	const PROP_ID = 'id';

    	/**
    	 * Title property name.
    	 */
    	const PROP_TITLE = 'title';

    	/**
    	 * URL property name.
    	 */
    	const PROP_URL = 'url';

    	/**
    	 * Type property name.
    	 */
    	const PROP_TYPE = 'type';

    	/**
    	 * Subtype property name.
    	 */
    	const PROP_SUBTYPE = 'subtype';

    	/**
    	 * Identifier for the 'any' type.
    	 */
    	const TYPE_ANY = 'any';

    	/**
    	 * Search handlers used by the controller.
    	 *
    	 * @since 5.0.0
    	 * @var WP_REST_Search_Handler[]
    	 */
    	protected $search_handlers = array();

    	/**
    	 * Constructor.
    	 *
    	 * @since 5.0.0
    	 *
    	 * @param array $search_handlers List of search handlers to use in the controller. Each search
    	 *                               handler instance must extend the `WP_REST_Search_Handler` class.
    	 */
    	public function __construct( array $search_handlers ) {
    		$this->namespace = 'wp/v2';
    		$this->rest_base = 'search';

    		foreach ( $search_handlers as $search_handler ) {
    			if ( ! $search_handler instanceof WP_REST_Search_Handler ) {
    				_doing_it_wrong(
    					__METHOD__,
    					/* translators: %s: PHP class name. */
    					sprintf( __( 'REST search handlers must extend the %s class.' ), 'WP_REST_Search_Handler' ),
    					'5.0.0'
    				);
    				continue;
    			}

    			$this->search_handlers[ $search_handler->get_type() ] = $search_handler;
    		}
    	}

    	/**
    	 * Registers the routes for the search controller.
    	 *
    	 * @since 5.0.0
    	 *
    	 * @see register_rest_route()
    	 */
    	public function register_routes() {
    		register_rest_route(
    			$this->namespace,
    			'/' . $this->rest_base,
    			array(
    				array(
    					'methods'             => WP_REST_Server::READABLE,
    					'callback'            => array( $this, 'get_items' ),
    					'permission_callback' => array( $this, 'get_items_permission_check' ),
    					'args'                => $this->get_collection_params(),
    				),
    				'schema' => array( $this, 'get_public_item_schema' ),
    			)
    		);
    	}

    	/**
    	 * Checks if a given request has access to search content.
    	 *
    	 * @since 5.0.0
    	 *
    	 * @param WP_REST_Request $request Full details about the request.
    	 * @return true|WP_Error True if the request has search access, WP_Error object otherwise.
    	 */
    	public function get_items_permission_check( $request ) {
    		return true;
    	}

    	/**
    	 * Retrieves a collection of search results.
    	 *
    	 * @since 5.0.0
    	 *
    	 * @param WP_REST_Request $request Full details about the request.
    	 * @return WP_REST_Response|WP_Error Response object on success, or WP_Error object on failure.
    	 */
    	public function get_items( $request ) {
    		$handler = $this->get_search_handler( $request );
    		if ( is_wp_error( $handler ) ) {
    			return $handler;
    		}

    		$result = $handler->search_items( $request );

    		if ( ! isset( $result[ WP_REST_Search_Handler::RESULT_IDS ] ) || ! is_array( $result[ WP_REST_Search_Handler::RESULT_IDS ] ) || ! isset( $result[ WP_REST_Search_Handler::RESULT_TOTAL ] ) ) {
    			return new WP_Error(
    				'rest_search_handler_error',
    				__( 'Internal search handler error.' ),
    				array( 'status' => 500 )
    			);
    		}

    		$ids = $result[ WP_REST_Search_Handler::RESULT_IDS ];

    		$is_head_request = $request->is_method( 'HEAD' );
    		if ( ! $is_head_request ) {
    			$results = array();

    			foreach ( $ids as $id ) {
    				$data      = $this->prepare_item_for_response( $id, $request );
    				$results[] = $this->prepare_response_for_collection( $data );
    			}
    		}

    		$total     = (int) $result[ WP_REST_Search_Handler::RESULT_TOTAL ];
    		$page      = (int) $request['page'];
    		$per_page  = (int) $request['per_page'];
    		$max_pages = (int) ceil( $total / $per_page );

    		if ( $page > $max_pages && $total > 0 ) {
    			return new WP_Error(
    				'rest_search_invalid_page_number',
    				__( 'The page number requested is larger than the number of pages available.' ),
    				array( 'status' => 400 )
    			);
    		}

    		$response = $is_head_request ? new WP_REST_Response( array() ) : rest_ensure_response( $results );
    		$response->header( 'X-WP-Total', $total );
    		$response->header( 'X-WP-TotalPages', $max_pages );

    		$request_params = $request->get_query_params();
    		$base           = add_query_arg( urlencode_deep( $request_params ), rest_url( sprintf( '%s/%s', $this->namespace, $this->rest_base ) ) );

    		if ( $page > 1 ) {
    			$prev_link = add_query_arg( 'page', $page - 1, $base );
    			$response->link_header( 'prev', $prev_link );
    		}
    		if ( $page < $max_pages ) {
    			$next_link = add_query_arg( 'page', $page + 1, $base );
    			$response->link_header( 'next', $next_link );
    		}

    		return $response;
    	}

    	/**
    	 * Prepares a single search result for response.
    	 *
    	 * @since 5.0.0
    	 * @since 5.6.0 The `$id` parameter can accept a string.
    	 * @since 5.9.0 Renamed `$id` to `$item` to match parent class for PHP 8 named parameter support.
    	 *
    	 * @param int|string      $item    ID of the item to prepare.
    	 * @param WP_REST_Request $request Request object.
    	 * @return WP_REST_Response Response object.
    	 */
    	public function prepare_item_for_response( $item, $request ) {
    		// Restores the more descriptive, specific name for use within this method.
    		$item_id = $item;

    		$handler = $this->get_search_handler( $request );
    		if ( is_wp_error( $handler ) ) {
    			return new WP_REST_Response();
    		}

    		$fields = $this->get_fields_for_response( $request );

    		$data = $handler->prepare_item( $item_id, $fields );
    		$data = $this->add_additional_fields_to_object( $data, $request );

    		$context = ! empty( $request['context'] ) ? $request['context'] : 'view';
    		$data    = $this->filter_response_by_context( $data, $context );

    		$response = rest_ensure_response( $data );

    		if ( rest_is_field_included( '_links', $fields ) || rest_is_field_included( '_embedded', $fields ) ) {
    			$links               = $handler->prepare_item_links( $item_id );
    			$links['collection'] = array(
    				'href' => rest_url( sprintf( '%s/%s', $this->namespace, $this->rest_base ) ),
    			);
    			$response->add_links( $links );
    		}

    		return $response;
    	}

    	/**
    	 * Retrieves the item schema, conforming to JSON Schema.
    	 *
    	 * @since 5.0.0
    	 *
    	 * @return array Item schema data.
    	 */
    	public function get_item_schema() {
    		if ( $this->schema ) {
    			return $this->add_additional_fields_schema( $this->schema );
    		}

    		$types    = array();
    		$subtypes = array();

    		foreach ( $this->search_handlers as $search_handler ) {
    			$types[]  = $search_handler->get_type();
    			$subtypes = array_merge( $subtypes, $search_handler->get_subtypes() );
    		}

    		$types    = array_unique( $types );
    		$subtypes = array_unique( $subtypes );

    		$schema = array(
    			'$schema'    => 'http://json-schema.org/draft-04/schema#',
    			'title'      => 'search-result',
    			'type'       => 'object',
    			'properties' => array(
    				self::PROP_ID      => array(
    					'description' => __( 'Unique identifier for the object.' ),
    					'type'        => array( 'integer', 'string' ),
    					'context'     => array( 'view', 'embed' ),
    					'readonly'    => true,
    				),
    				self::PROP_TITLE   => array(
    					'description' => __( 'The title for the object.' ),
    					'type'        => 'string',
    					'context'     => array( 'view', 'embed' ),
    					'readonly'    => true,
    				),
    				self::PROP_URL     => array(
    					'description' => __( 'URL to the object.' ),
    					'type'        => 'string',
    					'format'      => 'uri',
    					'context'     => array( 'view', 'embed' ),
    					'readonly'    => true,
    				),
    				self::PROP_TYPE    => array(
    					'description' => __( 'Object type.' ),
    					'type'        => 'string',
    					'enum'        => $types,
    					'context'     => array( 'view', 'embed' ),
    					'readonly'    => true,
    				),
    				self::PROP_SUBTYPE => array(
    					'description' => __( 'Object subtype.' ),
    					'type'        => 'string',
    					'enum'        => $subtypes,
    					'context'     => array( 'view', 'embed' ),
    					'readonly'    => true,
    				),
    			),
    		);

    		$this->schema = $schema;

    		return $this->add_additional_fields_schema( $this->schema );
    	}

    	/**
    	 * Retrieves the query params for the search results collection.
    	 *
    	 * @since 5.0.0
    	 *
    	 * @return array Collection parameters.
    	 */
    	public function get_collection_params() {
    		$types    = array();
    		$subtypes = array();

    		foreach ( $this->search_handlers as $search_handler ) {
    			$types[]  = $search_handler->get_type();
    			$subtypes = array_merge( $subtypes, $search_handler->get_subtypes() );
    		}

    		$types    = array_unique( $types );
    		$subtypes = array_unique( $subtypes );

    		$query_params = parent::get_collection_params();

    		$query_params['context']['default'] = 'view';

    		$query_params[ self::PROP_TYPE ] = array(
    			'default'     => $types[0],
    			'description' => __( 'Limit results to items of an object type.' ),
    			'type'        => 'string',
    			'enum'        => $types,
    		);

    		$query_params[ self::PROP_SUBTYPE ] = array(
    			'default'           => self::TYPE_ANY,
    			'description'       => __( 'Limit results to items of one or more object subtypes.' ),
    			'type'              => 'array',
    			'items'             => array(
    				'enum' => array_merge( $subtypes, array( self::TYPE_ANY ) ),
    				'type' => 'string',
    			),
    			'sanitize_callback' => array( $this, 'sanitize_subtypes' ),
    		);

    		$query_params['exclude'] = array(
    			'description' => __( 'Ensure result set excludes specific IDs.' ),
    			'type'        => 'array',
    			'items'       => array(
    				'type' => 'integer',
    			),
    			'default'     => array(),
    		);

    		$query_params['include'] = array(
    			'description' => __( 'Limit result set to specific IDs.' ),
    			'type'        => 'array',
    			'items'       => array(
    				'type' => 'integer',
    			),
    			'default'     => array(),
    		);

    		return $query_params;
    	}

    	/**
    	 * Sanitizes the list of subtypes, to ensure only subtypes of the passed type are included.
    	 *
    	 * @since 5.0.0
    	 *
    	 * @param string|array    $subtypes  One or more subtypes.
    	 * @param WP_REST_Request $request   Full details about the request.
    	 * @param string          $parameter Parameter name.
    	 * @return string[]|WP_Error List of valid subtypes, or WP_Error object on failure.
    	 */
    	public function sanitize_subtypes( $subtypes, $request, $parameter ) {
    		$subtypes = wp_parse_slug_list( $subtypes );

    		$subtypes = rest_parse_request_arg( $subtypes, $request, $parameter );
    		if ( is_wp_error( $subtypes ) ) {
    			return $subtypes;
    		}

    		// 'any' overrides any other subtype.
    		if ( in_array( self::TYPE_ANY, $subtypes, true ) ) {
    			return array( self::TYPE_ANY );
    		}

    		$handler = $this->get_search_handler( $request );
    		if ( is_wp_error( $handler ) ) {
    			return $handler;
    		}

    		return array_intersect( $subtypes, $handler->get_subtypes() );
    	}

    	/**
    	 * Gets the search handler to handle the current request.
    	 *
    	 * @since 5.0.0
    	 *
    	 * @param WP_REST_Request $request Full details about the request.
    	 * @return WP_REST_Search_Handler|WP_Error Search handler for the request type, or WP_Error object on failure.
    	 */
    	protected function get_search_handler( $request ) {
    		$type = $request->get_param( self::PROP_TYPE );

    		if ( ! $type || ! is_string( $type ) || ! isset( $this->search_handlers[ $type ] ) ) {
    			return new WP_Error(
    				'rest_search_invalid_type',
    				__( 'Invalid type parameter.' ),
    				array( 'status' => 400 )
    			);
    		}

    		return $this->search_handlers[ $type ];
    	}
    }
    ```

[View all references](https://developer.wordpress.org/reference/files/wp-includes/rest-api/endpoints/class-wp-rest-search-controller.php/)
[View on Trac](https://core.trac.wordpress.org/browser/tags/6.9.4/src/wp-includes/rest-api/endpoints/class-wp-rest-search-controller.php#L17)
[View on GitHub](https://github.com/WordPress/wordpress-develop/blob/6.9.4/src/wp-includes/rest-api/endpoints/class-wp-rest-search-controller.php#L17-L411)

## 󠀁[Related](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/?output_format=md#related)󠁿

| Uses | Description | 
| [WP_REST_Controller](https://developer.wordpress.org/reference/classes/wp_rest_controller/)`wp-includes/rest-api/endpoints/class-wp-rest-controller.php` |

Core base controller for managing and interacting with REST API items.

  |

## 󠀁[Changelog](https://developer.wordpress.org/reference/classes/wp_rest_search_controller/?output_format=md#changelog)󠁿

| Version | Description | 
| [5.0.0](https://developer.wordpress.org/reference/since/5.0.0/) | Introduced. |

## User Contributed Notes

You must [log in](https://login.wordpress.org/?redirect_to=https%3A%2F%2Fdeveloper.wordpress.org%2Freference%2Fclasses%2Fwp_rest_search_controller%2F)
before being able to contribute a note or feedback.